@define-mixin video-wrapper {
  position: relative;
  width: 100%;

  &::before {
    content: '';
    display: block;
    padding-top: 56.25%;
  }

  & img,
  & iframe {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    object-fit: cover;
    z-index: 1;
  }
}

@define-mixin image-overlay $value {
  &::after {
    content: '';

    @mixin abs-full;

    background: rgba(0, 0, 0, $value);
    z-index: 1;
    transition: background-color 0.3s;
  }
}

@define-mixin ratio $ratio {
  position: relative;

  &::before {
    content: '';
    display: block;
    padding-top: calc($ratio * 100%);
  }

  & .image__img {
    @mixin abs-full;

    z-index: 1;
  }
}

@define-mixin select-in-wrapper {
  appearance: none;
  width: 100%;
  height: 44px;
  margin: 0;
  padding: 0 10px;
  border: 0;
  background: none;
  line-height: 44px;
  color: var(--dark);

  &:focus {
    outline: var(--white);
  }
}

@define-mixin select-wrapper {
  position: relative;
  height: 44px;
  padding-right: 15px;
  border: 1px solid var(--gray);
  border-radius: 6px;
  background-color: var(--white);
  background-image: url("data:image/svg+xml;charset=utf8,<svg width='12' xmlns='http://www.w3.org/2000/svg' viewBox='0 0 490.688 490.688'><path fill='gray' d='M472.328 120.529L245.213 347.665 18.098 120.529c-4.237-4.093-10.99-3.975-15.083.262-3.992 4.134-3.992 10.687 0 14.82l234.667 234.667c4.165 4.164 10.917 4.164 15.083 0l234.667-234.667c4.237-4.093 4.354-10.845.262-15.083-4.093-4.237-10.845-4.354-15.083-.262-.089.086-.176.173-.262.262l-.021.001z'/><path d='M245.213 373.415a10.663 10.663 0 01-7.552-3.115L2.994 135.633c-4.093-4.237-3.975-10.99.262-15.083 4.134-3.992 10.687-3.992 14.82 0l227.136 227.115 227.115-227.136c4.093-4.237 10.845-4.354 15.083-.262 4.237 4.093 4.354 10.845.262 15.083-.086.089-.173.176-.262.262L252.744 370.279a10.672 10.672 0 01-7.531 3.136z'/></svg>");
  background-repeat: no-repeat;
  background-position-x: 95%;
  background-position-y: 15px;
}

@define-mixin list-reset {
  margin: 0;
  padding: 0;
  text-indent: 0;
  list-style-type: none;
}

@define-mixin icon $size {
  width: $size;
  height: $size;

  & svg {
    width: $size;
    height: $size;
  }
}

@define-mixin scrollbar {
  &::-webkit-scrollbar-track {
    -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);
    border-radius: 10px;
    background-color: #f5f5f5;
  }
  &::-webkit-scrollbar {
    width: 12px;
    background-color: #f5f5f5;
  }
  &::-webkit-scrollbar-thumb {
    border-radius: 10px;
    -webkit-box-shadow: inset 0 0 6px rgba(0, 0, 0, 0.3);
    background-color: #777;
  }
}

@define-mixin fade-in {
  opacity: 1;
  visibility: visible;
}

@define-mixin fade-out {
  opacity: 0;
  visibility: hidden;
}

@define-mixin bottom-line $color {
  position: relative;
  padding-bottom: 0.5em;

  &::after {
    content: '';
    position: absolute;
    bottom: 0;
    left: 50%;
    transform: translateX(-50%);
    height: 2px;
    width: 150px;
    background-color: $color;
  }
}

@define-mixin input-field {
  width: 100%;
  height: 44px;
  padding: 7px 10px;
  border: 1px solid var(--border);
  border-radius: 6px;
  color: var(--dark);
}

@define-mixin modal {
  @mixin fade-out;

  position: fixed;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: column;
  background: var(--white);
  z-index: 1001;
  pointer-events: none;
}

@define-mixin radio-wrapper-standard-check {
  border-radius: 11px;
  width: 12px;
  height: 12px;
  position: absolute;
  top: 9px;
  left: 10px;
  content: ' ';
  display: block;
  background: var(--primary);
}

@define-mixin custom-checkbox $color, $border {
  @mixin abs-full;

  appearance: none;
  opacity: 0;

  &:checked {
    & ~ span::before,
    & ~ label::before {
      border-color: $color;
    }

    & ~ span,
    & ~ label {
      color: $color;
    }

    & ~ span::after,
    & ~ label::after {
      opacity: 1;
    }
  }

  & ~ span,
  & ~ label {
    pointer-events: none;
    line-height: 48px; /* Fix mobile SEO score */
    transition: color 0.3s cubic-bezier(0.1, 0.1, 0.25, 1);

    @media (--m) {
      line-height: 36px;
    }

    &::before {
      content: '';
      position: absolute;
      top: 2px;
      left: 0;
      width: 19px;
      height: 19px;
      top: 13px;
      border: 1px solid $border;
      transition: border-color 0.3s cubic-bezier(0.1, 0.1, 0.25, 1);

      @media (--m) {
        top: 7px;
      }
    }

    &::after {
      content: '';
      position: absolute;
      top: 16px;
      left: 3px;
      width: 15px;
      height: 15px;
      background: $color;
      clip-path: polygon(0 0, 100% 0, 100% 100%, 0 100%);
      opacity: 0;

      @media (--m) {
        top: 10px;
      }
    }
  }
}

@define-mixin custom-radio $color: var(--primary), $border: var(--border) {
  @mixin abs-full;

  appearance: none;
  opacity: 0;

  &:checked {
    & ~ span::before,
    & ~ label::before {
      border-color: $color;
    }

    & ~ span,
    & ~ label {
      color: $color;
    }

    & ~ span::after,
    & ~ label::after {
      opacity: 1;
    }
  }

  & ~ span,
  & ~ label {
    pointer-events: none;

    &::before {
      content: '';
      position: absolute;
      top: 2px;
      left: 0;
      width: 18px;
      height: 18px;
      border: 1px solid $border;
      border-radius: 50%;
      transition: border-color 0.3s cubic-bezier(0.1, 0.1, 0.25, 1);
    }

    &::after {
      content: '';
      position: absolute;
      top: 5px;
      left: 3px;
      width: 13px;
      height: 13px;
      background: $color;
      clip-path: circle(50% at 50% 50%);
      opacity: 0;
    }
  }
}

@define-mixin radio-wrapper-standard {
  display: inline-block;
  position: relative;
  padding: 0 6px;

  & input[type='radio'] {
    display: none;
  }

  & label {
    color: var(--dark-3);
  }

  & label::before {
    content: ' ';
    display: inline-block;
    position: relative;
    top: 5px;
    margin: 0 10px 0 0;
    width: 18px;
    height: 18px;
    border-radius: 50%;
    border: 1px solid var(--border-light);
    background-color: transparent;
  }

  & input[type='radio']:checked + label::after {
    @mixin radio-wrapper-standard-check;
  }
}

@define-mixin item-with-line $border {
  margin-top: 0.5em;
  padding-top: 0.5em;
  border-top: 1px solid $border;

  &:first-child {
    margin-top: 0;
    padding-top: 0;
    border-top: 0;
  }
}
